
import Taro from '@tarojs/taro'
import { 
    SET_USERINFO, 
    SET_TOKEN, 
    SET_SESSIONKEY, 
    CLEAR_TOKEN, 
    CLEAR_USERINFO, 
    CLEAR_SESSIONKEY
} from '../constants/userInfo'

export type UserParam = {
  nickName?:string,
  phone?:string,
  avatarUrl?:string,
  city?: string,
  country?: string,
  province?: string,
  gender?: number,
  language?: string,
  timestamp?: number
}

export type DataParam = {
    token?: string
    session_key?: string,
    userInfo: UserParam
  }

type Action = {
  type?: string,
  data?: DataParam
}



const INIT_USER = {
    userInfo: Taro.getStorageSync('userInfo')?JSON.parse(Taro.getStorageSync('userInfo')):null,
    token: Taro.getStorageSync('token')||'',
    session_key: Taro.getStorageSync('session_key')||'',
}

export default function counter (state = INIT_USER, action: Action) {
    const {type, data} = action
    switch (type) {
      case SET_USERINFO:
          Taro.setStorageSync('userInfo',JSON.stringify(data?.userInfo))
          return {...state,...data}
      case SET_TOKEN:
          Taro.setStorageSync('token',data?.token)
          return {...state,...data}
      case SET_SESSIONKEY:
          Taro.setStorageSync('session_key',data?.session_key)
          return {...state,...data}
      case CLEAR_TOKEN:
          Taro.removeStorageSync('token')
          return {...state, token:''}
      case CLEAR_SESSIONKEY:
          Taro.removeStorageSync('session_key')
          return {...state, session_key:''}
      case CLEAR_USERINFO:
          Taro.removeStorageSync('userInfo')
          return {...state, userInfo: null}
      default:
        return state
    }
}